#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <lib_SLCException.h>

extern "C++"
{
    SLCException::SLCException( const char *inMsg )
    {
        eMsg = (char *) malloc( strlen( inMsg) + 1 );
        strcpy( eMsg, inMsg );
    }
    
    
    SLCException::SLCException( const SLCException& toCopy )
    {
        eMsg = (char *) malloc( strlen( toCopy.eMsg ) + 1 );
        strcpy( eMsg, toCopy.eMsg );
    }
    
    
    SLCException::~SLCException()
    { free( eMsg ); }
    
    
    SLCException& SLCException::operator=( const SLCException& toCopy ) 
    {
        if ( this == &toCopy )
            return *this;
    
        free( eMsg );
        eMsg = (char *) malloc( strlen( toCopy.eMsg ) + 1 );
        strcpy( eMsg, toCopy.eMsg );
        return *this;
    }
    
    
    const char* SLCException::getMessage()
    { return eMsg; }       
}
