#include <stdio.h>
#include <dlfcn.h>
#include <typeinfo>

#include <lib_func3.h>
#include <lib_SUBrtti.h>

void printType( SLCrtti& rtti_user );

SLCrtti* slc;
SUBrtti* sub;


void func3()
{
    slc = new SLCrtti( "rtti" );
    sub = new SUBrtti( "rtti" );

    printf( "slc user : %s\n", slc->getMessage() ); 
    printf( "sub user : %s\n\n", sub->getMessage() ); 

    printType( *slc );
    printType( *sub );
    printf( "\n" );

    delete slc;
    delete sub;
}


void printType( SLCrtti& rtti_user )
{
    if( typeid( rtti_user ) == typeid( *sub ) )
        printf( "Type of rtti_user is SUBrtti\n" );
    else if( typeid( rtti_user ) == typeid( *slc ) )
        printf( "Type of rtti_user is SLCrtti\n" );
}
